// Generated by rust-peg. Do not edit.
#![allow(non_snake_case, unused)]
use matcher::trie::node::{CompiledPattern};
use matcher::trie::node::{Node, TokenType};
use parsers::{SetParser, IntParser, Parser, OptionalParameter,
              HasOptionalParameter, GreedyParser};
use grammar;
use utils;
use std::str::FromStr;
use self::RuleResult::{Matched, Failed};
fn escape_default(s: &str) -> String {
    s.chars().flat_map(|c| c.escape_default()).collect()
}
fn char_range_at(s: &str, pos: usize) -> (char, usize) {
    let c = &s[pos..].chars().next().unwrap();
    let next_pos = pos + c.len_utf8();
    (*c, next_pos)
}
#[derive(Clone)]
enum RuleResult<T> { Matched(usize, T), Failed, }
#[derive(PartialEq, Eq, Debug, Clone)]
pub struct ParseError {
    pub line: usize,
    pub column: usize,
    pub offset: usize,
    pub expected: ::std::collections::HashSet<&'static str>,
}
pub type ParseResult<T> = Result<T, ParseError>;
impl ::std::fmt::Display for ParseError {
    fn fmt(&self, fmt: &mut ::std::fmt::Formatter)
     -> ::std::result::Result<(), ::std::fmt::Error> {
        try!(write ! (
             fmt , "error at {}:{}: expected " , self . line , self . column
             ));
        if self.expected.len() == 1 {
            try!(write ! (
                 fmt , "`{}`" , escape_default (
                 self . expected . iter (  ) . next (  ) . unwrap (  ) ) ));
        } else {
            let mut iter = self.expected.iter();
            try!(write ! (
                 fmt , "one of `{}`" , escape_default (
                 iter . next (  ) . unwrap (  ) ) ));
            for elem in iter {
                try!(write ! ( fmt , ", `{}`" , escape_default ( elem ) ));
            }
        }
        Ok(())
    }
}
impl ::std::error::Error for ParseError {
    fn description(&self) -> &str { "parse error" }
}
fn slice_eq(input: &str, state: &mut ParseState, pos: usize, m: &'static str)
 -> RuleResult<()> {
    #![inline]
    #![allow(dead_code)]
    let l = m.len();
    if input.len() >= pos + l &&
           &input.as_bytes()[pos..pos + l] == m.as_bytes() {
        Matched(pos + l, ())
    } else { state.mark_failure(pos, m) }
}
fn slice_eq_case_insensitive(input: &str, state: &mut ParseState, pos: usize,
                             m: &'static str) -> RuleResult<()> {
    #![inline]
    #![allow(dead_code)]
    let mut used = 0usize;
    let mut input_iter = input[pos..].chars().flat_map(|x| x.to_uppercase());
    for m_char_upper in m.chars().flat_map(|x| x.to_uppercase()) {
        used += m_char_upper.len_utf8();
        let input_char_result = input_iter.next();
        if input_char_result.is_none() ||
               input_char_result.unwrap() != m_char_upper {
            return state.mark_failure(pos, m);
        }
    }
    Matched(pos + used, ())
}
fn any_char(input: &str, state: &mut ParseState, pos: usize)
 -> RuleResult<()> {
    #![inline]
    #![allow(dead_code)]
    if input.len() > pos {
        let (_, next) = char_range_at(input, pos);
        Matched(next, ())
    } else { state.mark_failure(pos, "<character>") }
}
fn pos_to_line(input: &str, pos: usize) -> (usize, usize) {
    let mut remaining = pos;
    let mut lineno: usize = 1;
    for line in input.lines() {
        let line_length = line.len() + 1;
        if remaining < line_length { return (lineno, remaining + 1); }
        remaining -= line_length;
        lineno += 1;
    }
    return (lineno, remaining + 1);
}
struct ParseState {
    max_err_pos: usize,
    expected: ::std::collections::HashSet<&'static str>,
}
impl ParseState {
    fn new() -> ParseState {
        ParseState{max_err_pos: 0,
                   expected: ::std::collections::HashSet::new(),}
    }
    fn mark_failure(&mut self, pos: usize, expected: &'static str)
     -> RuleResult<()> {
        if pos > self.max_err_pos {
            self.max_err_pos = pos;
            self.expected.clear();
        }
        if pos == self.max_err_pos { self.expected.insert(expected); }
        Failed
    }
}
fn parse_pattern_file<'input>(input: &'input str, state: &mut ParseState,
                              pos: usize)
 -> RuleResult<Vec<CompiledPattern>> {
    {
        let start_pos = pos;
        {
            let seq_res =
                {
                    let mut repeat_pos = pos;
                    let mut repeat_value = vec!();
                    loop  {
                        let pos = repeat_pos;
                        let pos =
                            if repeat_value.len() > 0 {
                                let sep_res =
                                    parse_NEW_LINE(input, state, pos);
                                match sep_res {
                                    Matched(newpos, _) => { newpos }
                                    Failed => break ,
                                }
                            } else { pos };
                        let step_res = parse_pattern(input, state, pos);
                        match step_res {
                            Matched(newpos, value) => {
                                repeat_pos = newpos;
                                repeat_value.push(value);
                            }
                            Failed => { break ; }
                        }
                    }
                    if repeat_value.len() >= 1usize {
                        Matched(repeat_pos, repeat_value)
                    } else { Failed }
                };
            match seq_res {
                Matched(pos, patterns) => {
                    {
                        let seq_res =
                            match parse_NEW_LINE(input, state, pos) {
                                Matched(newpos, value) => {
                                    Matched(newpos, Some(value))
                                }
                                Failed => { Matched(pos, None) }
                            };
                        match seq_res {
                            Matched(pos, _) => {
                                {
                                    let match_str = &input[start_pos..pos];
                                    Matched(pos, { patterns })
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_pattern<'input>(input: &'input str, state: &mut ParseState,
                         pos: usize) -> RuleResult<CompiledPattern> {
    {
        let start_pos = pos;
        {
            let seq_res =
                {
                    let mut repeat_pos = pos;
                    let mut repeat_value = vec!();
                    loop  {
                        let pos = repeat_pos;
                        let step_res = parse_pattern_piece(input, state, pos);
                        match step_res {
                            Matched(newpos, value) => {
                                repeat_pos = newpos;
                                repeat_value.push(value);
                            }
                            Failed => { break ; }
                        }
                    }
                    if repeat_value.len() >= 1usize {
                        Matched(repeat_pos, repeat_value)
                    } else { Failed }
                };
            match seq_res {
                Matched(pos, pieces) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos,
                                {
                                    let mut pieces = pieces;
                                    utils::flatten_vec(pieces)
                                })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_pattern_piece<'input>(input: &'input str, state: &mut ParseState,
                               pos: usize) -> RuleResult<Vec<TokenType>> {
    {
        let choice_res = parse_parser_GREEDY(input, state, pos);
        match choice_res {
            Matched(pos, value) => Matched(pos, value),
            Failed => {
                let choice_res = parse_piece_literal(input, state, pos);
                match choice_res {
                    Matched(pos, value) => Matched(pos, value),
                    Failed => parse_piece_parser(input, state, pos),
                }
            }
        }
    }
}
fn parse_piece_literal<'input>(input: &'input str, state: &mut ParseState,
                               pos: usize) -> RuleResult<Vec<TokenType>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_literal(input, state, pos);
            match seq_res {
                Matched(pos, literal) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos,
                                {
                                    let unescaped_literal =
                                        grammar::unescape_literal(literal);
                                    vec!(TokenType:: Literal (
                                         unescaped_literal ))
                                })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_piece_parser<'input>(input: &'input str, state: &mut ParseState,
                              pos: usize) -> RuleResult<Vec<TokenType>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_PARSER_BEGIN(input, state, pos);
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res = parse_parser(input, state, pos);
                        match seq_res {
                            Matched(pos, parser) => {
                                {
                                    let seq_res =
                                        parse_PARSER_END(input, state, pos);
                                    match seq_res {
                                        Matched(pos, _) => {
                                            {
                                                let match_str =
                                                    &input[start_pos..pos];
                                                Matched(pos,
                                                        {
                                                            vec!(TokenType::
                                                                 Parser (
                                                                 parser ))
                                                        })
                                            }
                                        }
                                        Failed => Failed,
                                    }
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_parser<'input>(input: &'input str, state: &mut ParseState,
                        pos: usize) -> RuleResult<Box<Parser>> {
    {
        let choice_res = parse_parser_SET(input, state, pos);
        match choice_res {
            Matched(pos, value) => Matched(pos, value),
            Failed => parse_parser_INT(input, state, pos),
        }
    }
}
fn parse_parser_SET<'input>(input: &'input str, state: &mut ParseState,
                            pos: usize) -> RuleResult<Box<Parser>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_SET(input, state, pos);
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res =
                            parse_PARSER_PARAMS_BEGIN(input, state, pos);
                        match seq_res {
                            Matched(pos, _) => {
                                {
                                    let seq_res =
                                        parse_string(input, state, pos);
                                    match seq_res {
                                        Matched(pos, set) => {
                                            {
                                                let seq_res =
                                                    match parse_parser_SET_optional_params(input,
                                                                                           state,
                                                                                           pos)
                                                        {
                                                        Matched(newpos, value)
                                                        => {
                                                            Matched(newpos,
                                                                    Some(value))
                                                        }
                                                        Failed => {
                                                            Matched(pos, None)
                                                        }
                                                    };
                                                match seq_res {
                                                    Matched(pos, po) => {
                                                        {
                                                            let seq_res =
                                                                parse_PARSER_PARAMS_END(input,
                                                                                        state,
                                                                                        pos);
                                                            match seq_res {
                                                                Matched(pos,
                                                                        _) =>
                                                                {
                                                                    {
                                                                        let seq_res =
                                                                            parse_parser_name(input,
                                                                                              state,
                                                                                              pos);
                                                                        match seq_res
                                                                            {
                                                                            Matched(pos,
                                                                                    name)
                                                                            =>
                                                                            {
                                                                                {
                                                                                    let match_str =
                                                                                        &input[start_pos..pos];
                                                                                    Matched(pos,
                                                                                            {
                                                                                                let mut parser =
                                                                                                    SetParser::from_str(name,
                                                                                                                        set);
                                                                                                grammar::set_optional_params(&mut parser,
                                                                                                                             po.as_ref());
                                                                                                Box::new(parser)
                                                                                            })
                                                                                }
                                                                            }
                                                                            Failed
                                                                            =>
                                                                            Failed,
                                                                        }
                                                                    }
                                                                }
                                                                Failed =>
                                                                Failed,
                                                            }
                                                        }
                                                    }
                                                    Failed => Failed,
                                                }
                                            }
                                        }
                                        Failed => Failed,
                                    }
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_parser_SET_optional_params<'input>(input: &'input str,
                                            state: &mut ParseState,
                                            pos: usize)
 -> RuleResult<Vec<OptionalParameter<'input>>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_comma(input, state, pos);
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res =
                            {
                                let mut repeat_pos = pos;
                                let mut repeat_value = vec!();
                                loop  {
                                    let pos = repeat_pos;
                                    let pos =
                                        if repeat_value.len() > 0 {
                                            let sep_res =
                                                parse_comma(input, state,
                                                            pos);
                                            match sep_res {
                                                Matched(newpos, _) => {
                                                    newpos
                                                }
                                                Failed => break ,
                                            }
                                        } else { pos };
                                    let step_res =
                                        parse_parser_BASE_optional_param(input,
                                                                         state,
                                                                         pos);
                                    match step_res {
                                        Matched(newpos, value) => {
                                            repeat_pos = newpos;
                                            repeat_value.push(value);
                                        }
                                        Failed => { break ; }
                                    }
                                }
                                Matched(repeat_pos, repeat_value)
                            };
                        match seq_res {
                            Matched(pos, params) => {
                                {
                                    let match_str = &input[start_pos..pos];
                                    Matched(pos, { params })
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_parser_INT<'input>(input: &'input str, state: &mut ParseState,
                            pos: usize) -> RuleResult<Box<Parser>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_INT(input, state, pos);
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res =
                            match parse_parser_INT_optional_params(input,
                                                                   state, pos)
                                {
                                Matched(newpos, value) => {
                                    Matched(newpos, Some(value))
                                }
                                Failed => { Matched(pos, None) }
                            };
                        match seq_res {
                            Matched(pos, po) => {
                                {
                                    let seq_res =
                                        parse_parser_name(input, state, pos);
                                    match seq_res {
                                        Matched(pos, name) => {
                                            {
                                                let match_str =
                                                    &input[start_pos..pos];
                                                Matched(pos,
                                                        {
                                                            let mut parser =
                                                                IntParser::from_str(name);
                                                            grammar::set_optional_params(&mut parser,
                                                                                         po.as_ref());
                                                            Box::new(parser)
                                                        })
                                            }
                                        }
                                        Failed => Failed,
                                    }
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_parser_INT_optional_params<'input>(input: &'input str,
                                            state: &mut ParseState,
                                            pos: usize)
 -> RuleResult<Vec<OptionalParameter<'input>>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_PARSER_PARAMS_BEGIN(input, state, pos);
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res =
                            {
                                let mut repeat_pos = pos;
                                let mut repeat_value = vec!();
                                loop  {
                                    let pos = repeat_pos;
                                    let pos =
                                        if repeat_value.len() > 0 {
                                            let sep_res =
                                                parse_comma(input, state,
                                                            pos);
                                            match sep_res {
                                                Matched(newpos, _) => {
                                                    newpos
                                                }
                                                Failed => break ,
                                            }
                                        } else { pos };
                                    let step_res =
                                        parse_parser_BASE_optional_param(input,
                                                                         state,
                                                                         pos);
                                    match step_res {
                                        Matched(newpos, value) => {
                                            repeat_pos = newpos;
                                            repeat_value.push(value);
                                        }
                                        Failed => { break ; }
                                    }
                                }
                                Matched(repeat_pos, repeat_value)
                            };
                        match seq_res {
                            Matched(pos, params) => {
                                {
                                    let seq_res =
                                        parse_PARSER_PARAMS_END(input, state,
                                                                pos);
                                    match seq_res {
                                        Matched(pos, _) => {
                                            {
                                                let match_str =
                                                    &input[start_pos..pos];
                                                Matched(pos, { params })
                                            }
                                        }
                                        Failed => Failed,
                                    }
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_parser_GREEDY<'input>(input: &'input str, state: &mut ParseState,
                               pos: usize) -> RuleResult<Vec<TokenType>> {
    {
        let start_pos = pos;
        {
            let seq_res = parse_PARSER_BEGIN(input, state, pos);
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res = parse_GREEDY(input, state, pos);
                        match seq_res {
                            Matched(pos, _) => {
                                {
                                    let seq_res =
                                        parse_parser_name(input, state, pos);
                                    match seq_res {
                                        Matched(pos, name) => {
                                            {
                                                let seq_res =
                                                    parse_PARSER_END(input,
                                                                     state,
                                                                     pos);
                                                match seq_res {
                                                    Matched(pos, _) => {
                                                        {
                                                            let seq_res =
                                                                match parse_literal(input,
                                                                                    state,
                                                                                    pos)
                                                                    {
                                                                    Matched(newpos,
                                                                            value)
                                                                    => {
                                                                        Matched(newpos,
                                                                                Some(value))
                                                                    }
                                                                    Failed =>
                                                                    {
                                                                        Matched(pos,
                                                                                None)
                                                                    }
                                                                };
                                                            match seq_res {
                                                                Matched(pos,
                                                                        end_string)
                                                                => {
                                                                    {
                                                                        let match_str =
                                                                            &input[start_pos..pos];
                                                                        Matched(pos,
                                                                                {
                                                                                    let mut tokens =
                                                                                        Vec::new();
                                                                                    let mut parser =
                                                                                        GreedyParser::new(name.to_string());
                                                                                    if let Some(end_string)
                                                                                           =
                                                                                           end_string
                                                                                           {
                                                                                        parser.set_end_string(end_string.to_string());
                                                                                    }
                                                                                    tokens.push(TokenType::Parser(Box::new(parser)));
                                                                                    if let Some(end_string)
                                                                                           =
                                                                                           end_string
                                                                                           {
                                                                                        tokens.push(TokenType::Literal(end_string.to_string()));
                                                                                    }
                                                                                    tokens
                                                                                })
                                                                    }
                                                                }
                                                                Failed =>
                                                                Failed,
                                                            }
                                                        }
                                                    }
                                                    Failed => Failed,
                                                }
                                            }
                                        }
                                        Failed => Failed,
                                    }
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_parser_BASE_optional_param<'input>(input: &'input str,
                                            state: &mut ParseState,
                                            pos: usize)
 -> RuleResult<OptionalParameter<'input>> {
    {
        let choice_res =
            {
                let start_pos = pos;
                {
                    let seq_res = parse_MIN_LEN(input, state, pos);
                    match seq_res {
                        Matched(pos, name) => {
                            {
                                let seq_res =
                                    slice_eq(input, state, pos, "=");
                                match seq_res {
                                    Matched(pos, _) => {
                                        {
                                            let seq_res =
                                                parse_int(input, state, pos);
                                            match seq_res {
                                                Matched(pos, value) => {
                                                    {
                                                        let match_str =
                                                            &input[start_pos..pos];
                                                        Matched(pos,
                                                                {
                                                                    OptionalParameter::Int(name,
                                                                                           value)
                                                                })
                                                    }
                                                }
                                                Failed => Failed,
                                            }
                                        }
                                    }
                                    Failed => Failed,
                                }
                            }
                        }
                        Failed => Failed,
                    }
                }
            };
        match choice_res {
            Matched(pos, value) => Matched(pos, value),
            Failed => {
                let start_pos = pos;
                {
                    let seq_res = parse_MAX_LEN(input, state, pos);
                    match seq_res {
                        Matched(pos, name) => {
                            {
                                let seq_res =
                                    slice_eq(input, state, pos, "=");
                                match seq_res {
                                    Matched(pos, _) => {
                                        {
                                            let seq_res =
                                                parse_int(input, state, pos);
                                            match seq_res {
                                                Matched(pos, value) => {
                                                    {
                                                        let match_str =
                                                            &input[start_pos..pos];
                                                        Matched(pos,
                                                                {
                                                                    OptionalParameter::Int(name,
                                                                                           value)
                                                                })
                                                    }
                                                }
                                                Failed => Failed,
                                            }
                                        }
                                    }
                                    Failed => Failed,
                                }
                            }
                        }
                        Failed => Failed,
                    }
                }
            }
        }
    }
}
fn parse_MIN_LEN<'input>(input: &'input str, state: &mut ParseState,
                         pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, "min_len");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_MAX_LEN<'input>(input: &'input str, state: &mut ParseState,
                         pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, "max_len");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_INT<'input>(input: &'input str, state: &mut ParseState, pos: usize)
 -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, "INT");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_SET<'input>(input: &'input str, state: &mut ParseState, pos: usize)
 -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, "SET");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_GREEDY<'input>(input: &'input str, state: &mut ParseState,
                        pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, "GREEDY");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_PARSER_BEGIN<'input>(input: &'input str, state: &mut ParseState,
                              pos: usize) -> RuleResult<()> {
    slice_eq(input, state, pos, "%{")
}
fn parse_PARSER_END<'input>(input: &'input str, state: &mut ParseState,
                            pos: usize) -> RuleResult<()> {
    slice_eq(input, state, pos, "}")
}
fn parse_PARSER_PARAMS_BEGIN<'input>(input: &'input str,
                                     state: &mut ParseState, pos: usize)
 -> RuleResult<()> {
    slice_eq(input, state, pos, "(")
}
fn parse_PARSER_PARAMS_END<'input>(input: &'input str, state: &mut ParseState,
                                   pos: usize) -> RuleResult<()> {
    slice_eq(input, state, pos, ")")
}
fn parse_NEW_LINE<'input>(input: &'input str, state: &mut ParseState,
                          pos: usize) -> RuleResult<()> {
    slice_eq(input, state, pos, "\n")
}
fn parse_parser_name<'input>(input: &'input str, state: &mut ParseState,
                             pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, ":");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res = parse_identifier(input, state, pos);
                        match seq_res {
                            Matched(pos, name) => {
                                {
                                    let match_str = &input[start_pos..pos];
                                    Matched(pos, { name })
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_identifier<'input>(input: &'input str, state: &mut ParseState,
                            pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res =
                if input.len() > pos {
                    let (ch, next) = char_range_at(input, pos);
                    match ch {
                        'a' ...'z' | 'A' ...'Z' | '_' | '.' =>
                        Matched(next, ()),
                        _ => state.mark_failure(pos, "[a-zA-Z_.]"),
                    }
                } else { state.mark_failure(pos, "[a-zA-Z_.]") };
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res =
                            {
                                let mut repeat_pos = pos;
                                loop  {
                                    let pos = repeat_pos;
                                    let step_res =
                                        {
                                            let seq_res =
                                                if input.len() > pos {
                                                    let (ch, next) =
                                                        char_range_at(input,
                                                                      pos);
                                                    match ch {
                                                        'a' ...'z' | '-' | 'A'
                                                        ...'Z' | '0' ...'9' |
                                                        '_' | '.' =>
                                                        Matched(next, ()),
                                                        _ =>
                                                        state.mark_failure(pos,
                                                                           "[a-z-A-Z0-9_.]"),
                                                    }
                                                } else {
                                                    state.mark_failure(pos,
                                                                       "[a-z-A-Z0-9_.]")
                                                };
                                            match seq_res {
                                                Matched(pos, _) => {
                                                    {
                                                        let assert_res =
                                                            if input.len() >
                                                                   pos {
                                                                let (ch,
                                                                     next) =
                                                                    char_range_at(input,
                                                                                  pos);
                                                                match ch {
                                                                    '-' =>
                                                                    Matched(next,
                                                                            ()),
                                                                    _ =>
                                                                    state.mark_failure(pos,
                                                                                       "[-]"),
                                                                }
                                                            } else {
                                                                state.mark_failure(pos,
                                                                                   "[-]")
                                                            };
                                                        match assert_res {
                                                            Failed =>
                                                            Matched(pos, ()),
                                                            Matched(..) =>
                                                            Failed,
                                                        }
                                                    }
                                                }
                                                Failed => Failed,
                                            }
                                        };
                                    match step_res {
                                        Matched(newpos, value) => {
                                            repeat_pos = newpos;
                                        }
                                        Failed => { break ; }
                                    }
                                }
                                Matched(repeat_pos, ())
                            };
                        match seq_res {
                            Matched(pos, _) => {
                                {
                                    let match_str = &input[start_pos..pos];
                                    Matched(pos, { match_str })
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_string<'input>(input: &'input str, state: &mut ParseState,
                        pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res = slice_eq(input, state, pos, "\"");
            match seq_res {
                Matched(pos, _) => {
                    {
                        let seq_res =
                            parse_all_chars_until_quotation_mark(input, state,
                                                                 pos);
                        match seq_res {
                            Matched(pos, s) => {
                                {
                                    let seq_res =
                                        slice_eq(input, state, pos, "\"");
                                    match seq_res {
                                        Matched(pos, _) => {
                                            {
                                                let match_str =
                                                    &input[start_pos..pos];
                                                Matched(pos, { s })
                                            }
                                        }
                                        Failed => Failed,
                                    }
                                }
                            }
                            Failed => Failed,
                        }
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_literal<'input>(input: &'input str, state: &mut ParseState,
                         pos: usize) -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res =
                {
                    let mut repeat_pos = pos;
                    let mut repeat_value = vec!();
                    loop  {
                        let pos = repeat_pos;
                        let step_res =
                            {
                                let seq_res =
                                    {
                                        let assert_res =
                                            parse_PARSER_BEGIN(input, state,
                                                               pos);
                                        match assert_res {
                                            Failed => Matched(pos, ()),
                                            Matched(..) => Failed,
                                        }
                                    };
                                match seq_res {
                                    Matched(pos, _) => {
                                        {
                                            let seq_res =
                                                {
                                                    let assert_res =
                                                        parse_NEW_LINE(input,
                                                                       state,
                                                                       pos);
                                                    match assert_res {
                                                        Failed =>
                                                        Matched(pos, ()),
                                                        Matched(..) => Failed,
                                                    }
                                                };
                                            match seq_res {
                                                Matched(pos, _) => {
                                                    any_char(input, state,
                                                             pos)
                                                }
                                                Failed => Failed,
                                            }
                                        }
                                    }
                                    Failed => Failed,
                                }
                            };
                        match step_res {
                            Matched(newpos, value) => {
                                repeat_pos = newpos;
                                repeat_value.push(value);
                            }
                            Failed => { break ; }
                        }
                    }
                    if repeat_value.len() >= 1usize {
                        Matched(repeat_pos, ())
                    } else { Failed }
                };
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_all_chars_until_quotation_mark<'input>(input: &'input str,
                                                state: &mut ParseState,
                                                pos: usize)
 -> RuleResult<&'input str> {
    {
        let start_pos = pos;
        {
            let seq_res =
                {
                    let mut repeat_pos = pos;
                    let mut repeat_value = vec!();
                    loop  {
                        let pos = repeat_pos;
                        let step_res =
                            {
                                let seq_res =
                                    {
                                        let assert_res =
                                            slice_eq(input, state, pos, "\"");
                                        match assert_res {
                                            Failed => Matched(pos, ()),
                                            Matched(..) => Failed,
                                        }
                                    };
                                match seq_res {
                                    Matched(pos, _) => {
                                        any_char(input, state, pos)
                                    }
                                    Failed => Failed,
                                }
                            };
                        match step_res {
                            Matched(newpos, value) => {
                                repeat_pos = newpos;
                                repeat_value.push(value);
                            }
                            Failed => { break ; }
                        }
                    }
                    if repeat_value.len() >= 1usize {
                        Matched(repeat_pos, ())
                    } else { Failed }
                };
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos, { match_str })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
fn parse_comma<'input>(input: &'input str, state: &mut ParseState, pos: usize)
 -> RuleResult<()> {
    {
        let seq_res = slice_eq(input, state, pos, ",");
        match seq_res {
            Matched(pos, _) => {
                {
                    let mut repeat_pos = pos;
                    loop  {
                        let pos = repeat_pos;
                        let step_res = slice_eq(input, state, pos, " ");
                        match step_res {
                            Matched(newpos, value) => { repeat_pos = newpos; }
                            Failed => { break ; }
                        }
                    }
                    Matched(repeat_pos, ())
                }
            }
            Failed => Failed,
        }
    }
}
fn parse_int<'input>(input: &'input str, state: &mut ParseState, pos: usize)
 -> RuleResult<usize> {
    {
        let start_pos = pos;
        {
            let seq_res =
                {
                    let mut repeat_pos = pos;
                    let mut repeat_value = vec!();
                    loop  {
                        let pos = repeat_pos;
                        let step_res =
                            if input.len() > pos {
                                let (ch, next) = char_range_at(input, pos);
                                match ch {
                                    '0' ...'9' => Matched(next, ()),
                                    _ => state.mark_failure(pos, "[0-9]"),
                                }
                            } else { state.mark_failure(pos, "[0-9]") };
                        match step_res {
                            Matched(newpos, value) => {
                                repeat_pos = newpos;
                                repeat_value.push(value);
                            }
                            Failed => { break ; }
                        }
                    }
                    if repeat_value.len() >= 1usize {
                        Matched(repeat_pos, ())
                    } else { Failed }
                };
            match seq_res {
                Matched(pos, _) => {
                    {
                        let match_str = &input[start_pos..pos];
                        Matched(pos,
                                { usize::from_str(match_str).ok().unwrap() })
                    }
                }
                Failed => Failed,
            }
        }
    }
}
pub fn pattern_file<'input>(input: &'input str)
 -> ParseResult<Vec<CompiledPattern>> {
    let mut state = ParseState::new();
    match parse_pattern_file(input, &mut state, 0) {
        Matched(pos, value) => { if pos == input.len() { return Ok(value) } }
        _ => { }
    }
    let (line, col) = pos_to_line(input, state.max_err_pos);
    Err(ParseError{line: line,
                   column: col,
                   offset: state.max_err_pos,
                   expected: state.expected,})
}
pub fn pattern<'input>(input: &'input str) -> ParseResult<CompiledPattern> {
    let mut state = ParseState::new();
    match parse_pattern(input, &mut state, 0) {
        Matched(pos, value) => { if pos == input.len() { return Ok(value) } }
        _ => { }
    }
    let (line, col) = pos_to_line(input, state.max_err_pos);
    Err(ParseError{line: line,
                   column: col,
                   offset: state.max_err_pos,
                   expected: state.expected,})
}
